#include "syscall.h"

#define DEFAULT_SIZE 256
/* #define RESTRICT_ZERO */
/* #define RESTRICT_FF */
/* #define RESTRICT_CONTROL */
/* #define RESTRICT_NOPRINT */
/* #define RESTRICT_CHAR '\x0D' */

long data_value = 0xabadface;
int bss_value;

#ifdef USE_SYSCALL_WRAPPER
void __exit(int status)
{
  __r_exit(0, status);
}
int __read(int fd, void *buffer, int size)
{
  return __r_read(0, fd, buffer, size);
}
int __write(int fd, const void *buffer, int size)
{
  return __r_write(0, fd, buffer, size);
}
#if 0
int __open(const char *path, int flags, int mode)
{
  return __r_open(0, path, flags, mode);
}
#endif
int __close(int fd)
{
  return __r_close(0, fd);
}
#endif

void exit(int status)
{
  __exit(status);
}

unsigned char read1(int fd)
{
  unsigned char c = 0xFF;
  __read(fd, &c, 1);
  return c;
}

int write1(int fd, unsigned char c)
{
  return __write(fd, &c, 1);
}

int getchar(int fd)
{
  return read1(fd);
}

int putchar(int fd, int c)
{
  write1(fd, c);
  return c;
}

int gets(int fd, char *str)
{
  unsigned char c;
  while (1) {
    c = getchar(fd);
    if (c == '\n') break;
#ifdef RESTRICT_ZERO
    if (c == '\0') break;
#endif
#ifdef RESTRICT_FF
    if (c == '\xFF') break;
#endif
#ifdef RESTRICT_CONTROL
    if (c < 0x20) break;
#endif
#ifdef RESTRICT_NOPRINT
    if (c > 0x7F) break;
#endif
#ifdef RESTRICT_CHAR
    if (c == RESTRICT_CHAR) break;
#endif
    *(str++) = c;
  }
  *str = '\0';
  return 0;
}

int puts(int fd, char *str)
{
  for (; *str; str++)
    putchar(fd, *str);
  return 0;
}

int check_ok(char *buf, int size)
{
  puts(1, "This is " ARCH " server.");
#if defined(RESTRICT_ZERO) || defined(RESTRICT_FF) || defined(RESTRICT_CONTROL) || defined(RESTRICT_NOPRINT) || defined(RESTRICT_CHAR)
  puts(1, " (Difficult)");
#endif
  puts(1, "\n");
  puts(1, "Push Enter:\n");
  __read(0, buf, size);
  puts(1, "OK.\n");

  return 0;
}

int proc()
{
  char buf[16];

  /* ХåեСȼ */
  puts(1, "Input name:\n"); /* եå夵褦˲Ԥ */
  gets(0, buf);
  puts(1, "OK. Your name: ");
  puts(1, buf);
  puts(1, "\n");

#if 0 /* stager Ѥ¤ʤᡤʲ̵Ȥ */
  /*
   * stagerѤɻߤ뤿ˡɸϤ򥯥롥
   * ʤɸϤΤߥФϤ
   * LinuxĶsimple-inetdǼ¸ȤɸϤΤߥƤ
   * ɸϤФread()뤳Ȥɤ߹Ƥޤ
   * (ƱåȤdup2()Ƥ뤿ᡩ)
   * shutdown(0, SHUT_RD)ԤȤϤΤǤ뤳Ȥϲǽ
   * GDBΥߥ졼shutdown()бƤ뤫ɤ˰¸Ƥޤ
   * (ơбƤʤƥ㤬ۤȤɤǤ)
   * äɸϤ򤹤٤ƥ롥
   */
  __close(0);
  __close(1);
  __close(2);
#endif

  return 0;
}

int main()
{
  /*
   * å˥ХåեСΤνʬʶ뤿ˡ
   * ߡƤ
   */
  char buf[DEFAULT_SIZE];

  /*
   * ХåեѤΤǡԤνήѤ롥
   * ʲͳˤꡤϥ¤롥
   *   - check_ok()ǤEnterϤǤФǤ롥
   *   - ϥ礭Ȥ餫᥷륳ɤƤ
   *     Ϣ뤹뤳ȤǤƤޤ
   * ԥɤCRLFߤˣХȤˤʤ뤳ȤθƤ⥵ϣ
   * ʬʤϤǤ뤬ˤƤΤᣳХ٤
   * 륳()򤢤餫ϤƤȤǡ륳ɤ
   * ˽̾뤳ȤǤ뤫⤷ʤꤵΤ
   * ֤ޤǤޤǤ餽ϤɤΤǤϤʤȡ
   */
  check_ok(buf, 4);

  proc();

  exit(0);
  return 0;
}
